/*
* millis.c
*
* Created: 23.10.2014 00:09:18
*  Author: sschultewolter
*/


#include "millis.h"

static volatile uint32_t _millis;

ISR(TIMER0_COMPA_vect)
{
	_millis++;
}

void millis_init(void)
{
	// Globale Interrupts sperren
	cli();
	
	// Timer0 konfigurieren
	TCCR0A = (1 << WGM01);					// CTC Modus
	TCCR0B |= (1 << CS01) | (1 << CS00);	// Prescaler 64
	
	// (F_CPU/PRESCALER)/1000-1
	#if (F_CPU == 16000000UL)
	OCR0A = 249;
	#elif (F_CPU == 8000000UL)
	OCR0A = 124;
	#endif
	
	// Compare Interrupt erlauben
	TIMSK0 |= (1 << OCIE0A);
	
	// Globale Interrupts erlauben
	sei();
}

uint32_t millis(void)
{
	return _millis;
}